apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ admin_name }}
  name: {{ admin_name }}
  namespace: {{ namespace }}
spec:
{% if not do_hpa or has_dc.resources | length == 0 %}
  replicas: {{ admin_replicas }}
{% endif %}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ admin_name }}
  strategy:
    type: RollingUpdate
{% else %}
    name: {{ admin_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Rolling
{% endif %}
  template:
    metadata:
      labels:
        name: {{ admin_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ admin_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ admin_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
{% if (airbrake_id | default(False)) and (airbrake_key | default(False)) %}
        - name: AIRBRAKE_ID
          valueFrom:
            secretKeyRef:
              key: airbrake-id
              name: {{ admin_name }}-airbrake
        - name: AIRBRAKE_KEY
          valueFrom:
            secretKeyRef:
              key: airbrake-key
              name: {{ admin_name }}-airbrake
{% if airbrake_host | default(False) %}
        - name: AIRBRAKE_HOST
          valueFrom:
            secretKeyRef:
              key: airbrake-host
              name: {{ admin_name }}-airbrake
{% endif %}
{% else %}
        - name: AIRBRAKE_ID
          value: ""
        - name: AIRBRAKE_KEY
          value: ""
{% endif %}
        - name: API_HOSTNAME
          value: {{ admin_fqdn }}
        - name: API_HTTP_PORT
          value: '8080'
        - name: API_HTTP_PROTO
          value: https
        - name: API_PUB_PORT
          value: '443'
        - name: BIND_ADDR
          value: '0.0.0.0'
{% if (has_bluemind.resources | default([])) | length > 0 %}
        - name: BLUEMIND_ADMIN_USER
          valueFrom:
            secretKeyRef:
              key: admin-user
              name: {{ bluemind_name }}
        - name: BLUEMIND_ADMIN_TOKEN
          valueFrom:
            secretKeyRef:
              key: admin-token
              name: {{ bluemind_name }}
        - name: BLUEMIND_HOST
          valueFrom:
            secretKeyRef:
              key: api-host
              name: {{ bluemind_name }}
        - name: BLUEMIND_LDAP_PASSWORD
          valueFrom:
            secretKeyRef:
              key: bluemind-password
              name: {{ ldap_secret_name }}
        - name: BLUEMIND_PROTO
          value: {{ bluemind_proto | default('https') }}
{% endif %}
        - name: DB_CONNECTOR
          value: ldap
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
{% if (bluemind_api_token | default(False)) and (do_not_manage_bluemind_settings | default(False)) %}
        - name: DO_NOT_MANAGE_BLUEMIND_SETTINGS
          value: dont
{% endif %}
{% if (bluemind_api_token | default(False)) and bluemind_major_version in [ 3, '3' ] %}
        - name: DO_NOT_MANAGE_BLUEMIND_ROLES
          value: dont
{% endif %}
        - name: DOMAIN
          value: {{ root_domain }}
        - name: LDAP_BASE
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: LDAP_BINDPW
          valueFrom:
            secretKeyRef:
              key: wsweet-password
              name: {{ ldap_secret_name }}
        - name: LDAP_URL
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address }}
{% else %}
          value: {{ ldap_address }}
{% endif %}
        - name: LLNG_BIND_PW
          valueFrom:
            secretKeyRef:
              key: ssoapp-password
              name: {{ ldap_secret_name }}
        - name: LOG_TO_CONSOLE
          value: bla
{% if nextcloud_api_address | default(False) %}
        - name: NEXTCLOUD_ADMIN_PASSWORD
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ nextcloud_secret_name }}
        - name: NEXTCLOUD_ADMIN_USER
          valueFrom:
            secretKeyRef:
              key: admin-user
              name: {{ nextcloud_secret_name }}
        - name: NEXTCLOUD_HOST
          value: {{ nextcloud_api_address | urlsplit('hostname') }}
        - name: NEXTCLOUD_PROTO
          value: {{ nextcloud_api_address | urlsplit('scheme') }}
        - name: NEXTCLOUD_PORT
          value: '{{ nextcloud_api_address | urlsplit('port') }}'
{% endif %}
        - name: NODE_ENV
          value: production
{% if ldaps_address | default(False) and skip_ldap_verify | default(False) %}
        - name: NODE_TLS_REJECT_UNAUTHORIZED
          value: '0'
{% endif %}
        - name: PORTAL
          value: {{ lemon_portal }}
{% if do_exporters %}
        - name: PROMETHEUS_ENABLED
          value: yay
        - name: PROMETHEUS_PORT
          value: '9113'
{% endif %}
        - name: REDIS_HOST
          value: {{ cache_name }}-client
        - name: SMTP_HELO
          valueFrom:
            fieldRef:
              fieldPath: spec.nodeName
        - name: SERVE_STATIC
          value: FIXME
        - name: SMTP_HOST
{% if smtp_relay | default(False) %}
          value: {{ smtp_relay }}
        - name: SMTP_PORT
          value: "{{ smtp_port | default('25') }}"
        - name: SMTP_PROTO
          value: smtp
        - name: SMTP_TRUST_ANYCERT
          value: "{{ 'tru' if (smtp_port | default(25) | int == 25) else 'fals' }}e"
{% elif smtps_address | default(False) %}
          value: {{ smtps_address | urlsplit('hostname') }}
        - name: SMTP_PORT
          value: "{{ smtps_address | urlsplit('port') }}"
        - name: SMTP_PROTO
          value: smtps
        - name: SMTP_TRUST_ANYCERT
          value: ""
{% elif smtp_address | default(False) %}
          value: {{ smtp_address | urlsplit('hostname') }}
        - name: SMTP_PORT
          value: "{{ smtp_address | urlsplit('port') }}"
        - name: SMTP_PROTO
          value: smtp
        - name: SMTP_TRUST_ANYCERT
          value: yay
{% else %}
          value: ""
        - name: SMTP_PORT
          value: ""
        - name: SMTP_PROTO
          value: ""
        - name: SMTP_TRUST_ANYCERT
          value: ""
{% endif %}
        - name: SMTP_MAIL_FROM
          value: admin@{{ root_domain }}
        - name: SMTP_MAIL_REPLYTO
          value: noreply@{{ root_domain }}
        - name: TZ
          value: {{ timezone }}
        - name: USER_AGENT
          value: pong
{% if do_triggers == False or (opsimages | json_query("[?name=='wsweetadmin'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='wsweetadmin'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 20
          httpGet:
            httpHeaders:
            - name: Host
              value: {{ admin_fqdn }}
            path: /ping
            port: 8080
          initialDelaySeconds: 60
          periodSeconds: 20
          timeoutSeconds: 5
        name: admin
        ports:
        - containerPort: 8080
{% if do_exporters %}
        - containerPort: 9113
{% endif %}
        readinessProbe:
          httpGet:
            httpHeaders:
            - name: Host
              value: {{ admin_fqdn }}
            path: /ping
            port: 8080
          initialDelaySeconds: 20
          periodSeconds: 10
          timeoutSeconds: 3
        resources:
          limits:
            cpu: "{{ admin_cpu_limit }}"
            memory: "{{ admin_memory_limit }}"
          requests:
            cpu: "{{ admin_cpu_request }}"
            memory: "{{ admin_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
{% if k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /etc/ldap
          name: ldapconf
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ admin_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% if k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='wsweetadmin'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - admin
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='wsweetadmin'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
